/*
  bersetzung
  FinalWriter ARexx Macro zum automatischen bersetzen mit FLM
  $VER: 0.9 (22.10.1995) by olbiSOFT

  Dieser Script bersetzt ab der aktuellen Cursor-Position bis zum Text-Ende.
  Der Text wird dabei mit der bersetzung berschrieben.

  Changed by Denis Unger (16.07.1996)
*/


/* Nun kommen persnliche Einstellungen ...*/
/************************************************************************/
FLM            = 'FLM:FLM'             /* Programm FLM */
FWfont         = 'SoftSans_BoldItalic' /* Font fr nichtgefunden Wrter */
/************************************************************************/

Zeilenumbruch  = '0A'X

Options Results

gestartet = 0
if ~show('PORTS','FLM') then do          /* FLM schon gestartet ? */
    address command 'run >NIL: ' || FLM  /* starte FLM */
    address command "SYS:Rexxc/WaitForPort FLM"
    gestartet = 1        /* FLM wird nach bersetzung beendet */
end

/* Im Moment feste Sprache Englisch und Deutsch*/
  ShowMessage 1 0 '"bersetzungsrichtung ?" "" "" "  Deutsch->Englisch   " "Englisch->Deutsch" ""'        /* in welche Richtung soll bersetzt werden */
    Richtung = RESULT
  if Richtung = '2' then do
    address FLM SETLANGUAGE englisch
  end
  else do
    address FLM SETLANGUAGE deutsch
  end

  ShowMessage 1 0 '"Soll der Text nun von Cursor-Position" "bis zum Dokument-Ende bersetzt werde ?" "" "Ja" "Nein" ""'
  if RESULT = 2 then exit

do forever

    markiere()        /* markiere zwei Worte */
    WortOrg = getASCII()        /* hole Worte */
    if WortOrg = "" then do
        ShowMessage 1 0 '"Textbersetzung beendet." "" "" "OK" "" ""'
        leave           /* bersetzung beenden */
    end

    if pos(Zeilenumbruch,WortOrg) ~= 0 then do
      /* wenn im Text noch ein Zeilenumbruch dann ein Wort weniger anwhlen */
        demarkiere()
        WortOrg = getASCII()        /* hole den Rest */
    end

    Uebersetzung = uebersetze(WortOrg)   /* versuche eine bersetzung */
    if Uebersetzung ~= '' then do        /* wenn das bersetzen erfogreich war */
       Type Uebersetzung                 /* schreibe bersetzung */
    end
    else do        /* falls keine bersetzung mglich */
       if pos(' ',WortOrg) ~= 0 then do
          /* wenn noch zwei Worte angewhlt sind */
            demarkiere()            /* dann ein Wort weniger anwhlen */
            WortOrg = getASCII()    /* und den Rest holen */
            Uebersetzung = uebersetze(WortOrg)        /* versuche eine bersetzung */
       end
       if Uebersetzung ~= '' then do 
            Type Uebersetzung   /* schreibe bersetzung wenn gelungen */
       end
       else do 
           Font FWfont /* Font ndern*/
       end
    end
    CtrlDown
    if length(WortOrg) > 0 then Cursor 'Left'
    Cursor 'Right'      /* springe bis zum nchsten Wort */
    CtrlUp
end

if gestartet = 1 then do
 /* wurde FLM durch das Script gestartet, so wird es nun auch wieder beendet */
 address FLM QUIT
end

exit

/* --------------------- Funktionen --------------------- */




/* markiere bis zum bernchsten Wort */
markiere:
   
   CtrlDown        
   ShiftDown
   Cursor 'Right'
   Cursor 'Right'
   CtrlUP
   ShiftUp

   return ''



/* deselektiere das letzte Wort */
demarkiere:

   CtrlDown
   ShiftDown
   Cursor 'Left'
   CtrlUp
   ShiftUp

   return ''


/* entfernt alle nicht ASCII Zeichen am ende der Zeichenkette 
   deselektiert diese und liefert den Rest zurck */
getASCII: PROCEDURE

    ShiftDown
    Extract
    Zeichen = RESULT
    do while length(Zeichen) > 0
        ASCII_rechts = C2D(right(Zeichen,1))
        if (((ASCII_rechts >= 65) & (ASCII_rechts <= 90)) | ((ASCII_rechts >= 97) & (ASCII_rechts <= 122))) then leave /* solange noch Zeichen da exrahiere von Hinten alles was kein Buchstabe ist */
        Cursor 'Left'
        Zeichen = left(Zeichen,length(Zeichen)-1)
    end
    ShiftUp
    return Zeichen



/* versucht das bergebene Wort zu bersetzen und liefert das Ergebnis zurck */
uebersetze: PROCEDURE
    ARG WortOrg

    address FLM LOOKWORD WortOrg        /* bersetze das Wort */
    address FLM FOUND        /* teste ob bersetzung erfolgreich */
    gefunden = RESULT
    if gefunden = '0' then do        /* wenn erfolgreich dann */
        address FLM TAKEWORD        /* hole bersetzung */
       return RESULT
    end
    else return ''        /* liefere nix wenn keine bersetzung mglich */
